/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.locojoy.base.Marshal.OctetsStream
 *  com.locojoy.base.Octets
 *  fire.pb.PReqRoleInfoProc
 *  fire.pb.PropConf$Battle
 *  fire.pb.attr.SRefreshPetData
 *  fire.pb.attr.SRefreshRoleData
 *  fire.pb.buff.BuffRoleImpl
 *  fire.pb.buff.Module
 *  fire.pb.buff.continual.ConstantlyBuff
 *  fire.pb.buff.continual.ConstantlyBuffConfig
 *  fire.pb.effect.PetImpl
 *  fire.pb.effect.RoleImpl
 *  fire.pb.main.ConfigManager
 *  fire.pb.main.Gs
 *  fire.pb.pet.PetColumn
 *  fire.pb.skill.BuffUnit
 *  fire.pb.skill.Result
 *  fire.pb.talk.MessageMgr
 *  fire.pb.util.Misc
 *  fire.script.AbstractJSEngine
 *  fire.script.JavaScript
 *  fire.script.SceneJSEngine
 *  mkdb.Bean
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.Item
 *  xbean.Pod
 *  xbean.RecoveryAttr
 *  xtable.Quality
 */
package fire.pb.item;

import com.locojoy.base.Marshal.OctetsStream;
import com.locojoy.base.Octets;
import fire.pb.PReqRoleInfoProc;
import fire.pb.PropConf;
import fire.pb.attr.SRefreshPetData;
import fire.pb.attr.SRefreshRoleData;
import fire.pb.buff.BuffRoleImpl;
import fire.pb.buff.continual.ConstantlyBuff;
import fire.pb.buff.continual.ConstantlyBuffConfig;
import fire.pb.effect.PetImpl;
import fire.pb.effect.RoleImpl;
import fire.pb.item.Commontext;
import fire.pb.item.Effect;
import fire.pb.item.FoodItemAttr;
import fire.pb.item.ItemBase;
import fire.pb.item.ItemMgr;
import fire.pb.item.Module;
import fire.pb.item.QualityToEffect;
import fire.pb.item.SItemBuff;
import fire.pb.item.UseItemHandler;
import fire.pb.main.ConfigManager;
import fire.pb.main.Gs;
import fire.pb.pet.PetColumn;
import fire.pb.skill.BuffUnit;
import fire.pb.skill.Result;
import fire.pb.talk.MessageMgr;
import fire.pb.util.Misc;
import fire.script.AbstractJSEngine;
import fire.script.JavaScript;
import fire.script.SceneJSEngine;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import mkdb.Bean;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.Item;
import xbean.Pod;
import xbean.RecoveryAttr;
import xtable.Quality;

public abstract class FoodItem
extends ItemBase {
    protected RecoveryAttr quality;

    public FoodItem(ItemMgr im, int itemid) {
        super(im, itemid);
        if (!this.checkHasQuality()) {
            this.quality = null;
            return;
        }
        this.quality = Pod.newRecoveryAttr();
        this.quality.setQuality(this.genQuality());
        this.insertQuality();
    }

    public FoodItem(ItemMgr im, int itemid, Bean extinfo) {
        super(im, itemid);
        if (!this.checkHasQuality()) {
            this.quality = null;
            return;
        }
        this.quality = Pod.newRecoveryAttr();
        this.quality.setQuality(this.genQuality());
        this.insertQuality();
        this.setExtinfo(extinfo);
    }

    private void insertQuality() {
        long extkey = Quality.insert((RecoveryAttr)this.quality);
        this.itemData.setExtid(extkey);
    }

    private final boolean checkHasQuality() {
        FoodItemAttr fattr = (FoodItemAttr)this.itemAttr;
        return fattr.是否有品质 == 1;
    }

    private void setExtinfo(Bean extinfo) {
        if (!this.checkHasQuality()) {
            return;
        }
        if (extinfo instanceof RecoveryAttr) {
            this.quality = (RecoveryAttr)extinfo;
            this.insertQuality();
        }
    }

    public FoodItem(ItemMgr im, Item item) {
        super(im, item);
        if (!this.checkHasQuality()) {
            this.quality = null;
            return;
        }
        this.quality = Quality.select((Long)item.getExtid());
        if (this.quality == null) {
            Module.getInstance().getLogger().error((Object)new StringBuffer().append("食品库不完整,请检查原因:").append(item.getId()));
        }
    }

    public void setQuality(int q) {
        if (this.quality != null) {
            this.quality.setQuality(q);
        }
    }

    @Override
    public void onDeleted() {
        if (!this.checkHasQuality()) {
            return;
        }
        if (Gs.isDebug() && this.itemData.getExtid() <= 0L) {
            throw new RuntimeException("数据错误");
        }
        Quality.remove((Long)this.itemData.getExtid());
    }

    @Override
    public void onInserted() {
    }

    private int genQuality() {
        return Misc.getRandomBetween((int)1, (int)100);
    }

    @Override
    protected List<Effect> getAppendEffects(int num) {
        ArrayList<Effect> effectlist = new ArrayList<Effect>();
        if (!this.checkHasQuality()) {
            if (this.itemAttr == null || !(this.itemAttr instanceof FoodItemAttr)) {
                return effectlist;
            }
            FoodItemAttr ia = (FoodItemAttr)this.itemAttr;
            if (ia.getAddhp() != 0) {
                effectlist.add(new Effect(81, ia.addhp * num));
            }
            if (ia.getAddmp() != 0) {
                effectlist.add(new Effect(101, ia.addmp * num));
            }
        } else {
            List<Effect> effects = QualityToEffect.getInstance().getEffect(this.itemData.getId(), this.quality.getQuality());
            for (Effect effect : effects) {
                effectlist.add(new Effect(effect.effectid, effect.value * (float)num));
            }
        }
        return effectlist;
    }

    public RecoveryAttr getExtInfo() {
        return this.quality;
    }

    public int getQuality() {
        if (this.quality == null) {
            return 0;
        }
        return this.quality.getQuality();
    }

    @Override
    protected Commontext.UseResult appendToRole(long roleId, int usenum) {
        Commontext.UseResult ret = super.appendToRole(roleId, usenum);
        return ret;
    }

    @Override
    public Octets getTips() {
        if (this.os == null) {
            this.os = new OctetsStream();
            if (this.quality != null) {
                this.os.marshal(this.quality.getQuality());
            } else {
                this.os.marshal(0);
            }
        }
        return this.os;
    }

    @Override
    public UseItemHandler getUseItemHandler() {
        return new FoodUseHandler();
    }

    private static class FoodUseHandler
    implements UseItemHandler {
        private FoodUseHandler() {
        }

        @Override
        public Commontext.UseResult onUse(long roleId, ItemBase bi, int usednum) {
            BuffRoleImpl rolebuff = new BuffRoleImpl(roleId, false);
            SItemBuff sItemBuff = (SItemBuff)ConfigManager.getInstance().getConf(SItemBuff.class).get(bi.getItemId());
            if (sItemBuff == null) {
                return Commontext.UseResult.FAIL;
            }
            List<BuffUnit> buffArgs = null;
            try {
                buffArgs = Module.getItemBuffs(sItemBuff.outskill_id);
                if (buffArgs == null || buffArgs.size() < 1) {
                    return Commontext.UseResult.FAIL;
                }
                for (BuffUnit buffarg : buffArgs) {
                    if (buffarg == null) continue;
                    ConstantlyBuffConfig buffconf = fire.pb.buff.Module.getInstance().getDefaultCBuffConfig(buffarg.buffIndex);
                    if (buffconf != null) {
                        ArrayList<String> para;
                        int nqulity = 1;
                        if (bi instanceof FoodItem) {
                            nqulity = ((FoodItem)bi).getQuality();
                        }
                        JavaScript js = null;
                        js = (JavaScript)buffarg.effectJavascriptMap.get(81);
                        if (js == null) {
                            js = (JavaScript)buffarg.effectJavascriptMap.get(101);
                        }
                        boolean bSp = false;
                        if (js == null && (js = (JavaScript)buffarg.effectJavascriptMap.get(121)) != null) {
                            bSp = true;
                        }
                        if (js == null) {
                            throw new NullPointerException("配置有误");
                        }
                        SceneJSEngine jsengine = new SceneJSEngine();
                        jsengine.setQuality(nqulity);
                        Double val = js.eval((AbstractJSEngine)jsengine, null, null);
                        if (bSp) {
                            RoleImpl role = new RoleImpl(rolebuff.getRoleId(), false);
                            if (role.getSp() >= PropConf.Battle.BATTLEENTER_SP_MAX) {
                                MessageMgr.psendMsgNotify((long)roleId, (int)160251, null);
                                return Commontext.UseResult.FAIL;
                            }
                            role.addSp(val.intValue(), PropConf.Battle.BATTLEENTER_SP_MAX);
                            SRefreshRoleData data = new SRefreshRoleData();
                            data.datas.put(120, Float.valueOf(role.getSp()));
                            Procedure.psendWhileCommit((long)rolebuff.getRoleId(), (Protocol)data);
                            return Commontext.UseResult.SUCC;
                        }
                        ConstantlyBuff oldbuff = rolebuff.getBuff(buffarg.buffIndex);
                        long oldval = 0L;
                        if (oldbuff != null) {
                            oldval = oldbuff.getAmount();
                        }
                        ConstantlyBuff buff = fire.pb.buff.Module.getInstance().createConstantlyBuff(buffarg.buffIndex);
                        buff.setAmount(val.longValue() + oldval);
                        if (buff == null) continue;
                        rolebuff.addCBuffWithSP(buff);
                        this.checkBuff(roleId, buff);
                        if (buff.getId() == 500009) {
                            para = new ArrayList<String>(1);
                            para.add(String.valueOf(val.intValue()));
                            MessageMgr.psendMsgNotify((long)roleId, (int)150093, para);
                            Procedure.pexecuteWhileCommit((Procedure)new PReqRoleInfoProc(roleId));
                            continue;
                        }
                        if (buff.getId() != 500010) continue;
                        para = new ArrayList(1);
                        para.add(String.valueOf(val.intValue()));
                        MessageMgr.psendMsgNotify((long)roleId, (int)150094, para);
                        Procedure.pexecuteWhileCommit((Procedure)new PReqRoleInfoProc(roleId));
                        continue;
                    }
                    throw new NullPointerException("道具战斗外使用带了一次性buff！");
                }
                return Commontext.UseResult.SUCC;
            }
            catch (Exception e) {
                e.printStackTrace();
                return Commontext.UseResult.FAIL;
            }
        }

        private void checkBuff(long roleId, ConstantlyBuff buff) {
            Result result;
            long res;
            BuffRoleImpl bri = new BuffRoleImpl(roleId, false);
            RoleImpl role = new RoleImpl(roleId, false);
            SRefreshRoleData sendrole = new SRefreshRoleData();
            if (buff.getId() == 500009) {
                res = role.getUplimithp() - role.getHp();
                if (buff.getAmount() < res) {
                    res = buff.getAmount();
                }
                if (res > 0L) {
                    role.addHp((int)res);
                    sendrole.datas.put(80, Float.valueOf(role.getHp()));
                    buff.setAmount(buff.getAmount() - res);
                    if (buff.getAmount() == 0L) {
                        bri.removeCBuffWithSP(500009);
                    } else {
                        result = new Result(true);
                        result.addAddedBuff(buff);
                        bri.psendSBuffChangeResult(result);
                    }
                }
            }
            if (buff.getId() == 500010) {
                res = role.getMaxMp() - role.getMp();
                if (buff.getAmount() < res) {
                    res = buff.getAmount();
                }
                if (res > 0L) {
                    role.addMp((int)res);
                    sendrole.datas.put(100, Float.valueOf(role.getMp()));
                    buff.setAmount(buff.getAmount() - res);
                    if (buff.getAmount() == 0L) {
                        bri.removeCBuffWithSP(500010);
                    } else {
                        result = new Result(true);
                        result.addAddedBuff(buff);
                        bri.psendSBuffChangeResult(result);
                    }
                }
            }
            if (!sendrole.datas.isEmpty()) {
                Procedure.psendWhileCommit((long)roleId, (Protocol)sendrole);
            }
            PetImpl pet = null;
            PetColumn depotcol = new PetColumn(roleId, 1, false);
            Set existIds = depotcol.getPetsMap().keySet();
            if (existIds.size() > 0) {
                Iterator iterator = existIds.iterator();
                while (iterator.hasNext()) {
                    Result result2;
                    long res2;
                    int petkey = (Integer)iterator.next();
                    if (petkey == -1 || petkey == 0) continue;
                    pet = new PetImpl(roleId, petkey, false);
                    SRefreshPetData sendpet = new SRefreshPetData();
                    if (buff.getId() == 500009) {
                        res2 = pet.getMaxHp() - pet.getHp();
                        if (buff.getAmount() < res2) {
                            res2 = buff.getAmount();
                        }
                        if (res2 > 0L) {
                            pet.addHp((int)res2);
                            sendpet.datas.put(80, Float.valueOf(pet.getHp()));
                            buff.setAmount(buff.getAmount() - res2);
                            if (buff.getAmount() == 0L) {
                                bri.removeCBuffWithSP(500010);
                            } else {
                                result2 = new Result(true);
                                result2.addAddedBuff(buff);
                                bri.psendSBuffChangeResult(result2);
                            }
                        }
                    }
                    if (buff.getId() == 500010) {
                        res2 = pet.getMaxMp() - pet.getMp();
                        if (buff.getAmount() < res2) {
                            res2 = buff.getAmount();
                        }
                        if (res2 > 0L) {
                            pet.addMp((int)res2);
                            sendpet.datas.put(100, Float.valueOf(pet.getMp()));
                            buff.setAmount(buff.getAmount() - res2);
                            if (buff.getAmount() == 0L) {
                                bri.removeCBuffWithSP(500010);
                            } else {
                                result2 = new Result(true);
                                result2.addAddedBuff(buff);
                                bri.psendSBuffChangeResult(result2);
                            }
                        }
                    }
                    if (sendpet.datas.isEmpty()) continue;
                    sendpet.petkey = petkey;
                    sendpet.columnid = 1;
                    Procedure.psendWhileCommit((long)roleId, (Protocol)sendpet);
                }
            }
        }
    }
}

